CREATE VIEW IF NOT EXISTS V_Invoice_Calculator AS WITH
    cteTotalSum AS (
        SELECT 
            A.*,
			/*_invoice_total_price*/(A._ind_price_sum - A._ind_discount_sum + A._inv_tax) /*_invoice_total_price*/ AS _invoice_total_price,
			MAX(
				CASE
				WHEN A.invIsDiscountPercent = 1
					THEN invDiscount * /*_invoice_total_price*/(A._ind_price_sum - A._ind_discount_sum + A._inv_tax) /*_invoice_total_price*/
					ELSE invDiscount
				END
			,0) AS _invoice_final_discount
        FROM (
            SELECT
                OD.invID,
                MAX(O.invIsDiscountPercent) AS invIsDiscountPercent,
                MAX(O.invDiscount) AS invDiscount,
				/* _ind_price_sum */
				SUM(
					ROUND (OD.indCount * OD.indPrice , 2)
				) AS _ind_price_sum,
				/* _ind_discount_sum */
				SUM(
					CASE
                    WHEN OD.indIsDiscountPercent = 1
                        THEN OD.indDiscount * OD.indPrice * OD.indCount
                        ELSE OD.indDiscount * OD.indCount
                    END
				) AS _ind_discount_sum,
				/* _ind_discount_sum */
				SUM(
					(
						OD.indPrice -
						(
							CASE
							WHEN OD.indIsDiscountPercent = 1
								THEN OD.indDiscount * OD.indPrice
								ELSE OD.indDiscount
							END
						)
					) * O.invTax * OD.indCount
				) AS _inv_tax
            FROM T_Invoice O
            INNER JOIN T_Invoice_Details OD ON O.ID = OD.invID
            GROUP BY O.ID
        ) AS A
        GROUP BY A.invID
    )
SELECT
    invID,
	_ind_price_sum,
	_ind_discount_sum,
	_inv_tax,
	_invoice_total_price,
	_invoice_final_discount,
	(CASE WHEN _invoice_total_price <= 0 THEN _invoice_total_price ELSE _invoice_total_price - _invoice_final_discount END) AS _invoice_final_price
FROM cteTotalSum;
CREATE INDEX IF NOT EXISTS `index_T_Invoice_Details_invID` ON `T_Invoice_Details` (`invID`);